# -*- coding: utf-8 -*-
from setuphelpers import *
import xml.etree.ElementTree as ET

app_uninstallkey = "TreeSize Free_is1"


def install():
    bin_name = glob.glob("TreeSizeFreeSetup*.exe")[0]
    install_exe_if_needed(
        bin_name,
        silentflags="/VERYSILENT /SUPPRESSMSGBOXES /NORESTART",
        key=app_uninstallkey,
        min_version=control.get_software_version(),
    )
    # Adding QuietUninstallString
    quiet_uninstall_string = installed_softwares(uninstallkey=app_uninstallkey)[0]["uninstall_string"] + " /VERYSILENT /SUPPRESSMSGBOXES /NORESTART"
    register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)


def session_setup():
    print("Disabling: update check, pop-ups and context menu once")
    # C:\Users\username\AppData\Roaming\JAM Software\TreeSize Free\GlobalOptions.xml
    user_conf_dir = makepath(application_data, "JAM Software", "TreeSize Free")
    user_conf_file = makepath(user_conf_dir, "GlobalOptions.xml")
    user_conf_content = """<?xml version="1.0" encoding="UTF-8"?>
<GlobalOptions Version="3" AppVersion="0" Type="TGlobalOptions">
	<ContextMenuEntries>4</ContextMenuEntries>
	<AskForRestartAsAdministrator>False</AskForRestartAsAdministrator>
	<DoNotAskAgainList Type="TSerializableStringIntDictionary"></DoNotAskAgainList>
	<CheckForUpdateOptions Type="TCheckForUpdateOptions">
		<LatestOnlineVersion>0</LatestOnlineVersion>
		<LastAutomaticCheckForUpdate>0</LastAutomaticCheckForUpdate>
		<CheckForUpdatesAutomatically>False</CheckForUpdatesAutomatically>
	</CheckForUpdateOptions>
</GlobalOptions>
"""
    if not isdir(user_conf_dir):
        mkdirs(user_conf_dir)
    if isfile(user_conf_file):
        user_conf_tree = ET.parse(user_conf_file)
        user_conf_content = user_conf_tree.getroot()

        for conf in user_conf_content.iter("CheckForUpdateOptions"):
            if conf.get("Type") == "TCheckForUpdateOptions":
                for children in conf.getchildren():
                    if children.tag == "CheckForUpdatesAutomatically":
                        children.text = "False"
                        user_conf_tree.write(user_conf_file, encoding="utf-8")
        # 	<DoNotAskAgainList Type="TSerializableStringIntDictionary"></DoNotAskAgainList>
        if registry_readstring(HKEY_CURRENT_USER, r"Software\WAPT\TreeSize Free", "DisableContextMenuEntriesOnce") == "Done":
            for conf in user_conf_content.iter("ContextMenuEntries"):
                conf.text = "4"
                user_conf_tree.write(user_conf_file, encoding="utf-8")
                registry_setstring(HKEY_CURRENT_USER, r"Software\WAPT\TreeSize Free", "DisableContextMenuEntriesOnce", "Done")
    else:
        file_open = open(user_conf_file, "w")
        file_open.write(user_conf_content)
        file_open.close()
        registry_setstring(HKEY_CURRENT_USER, r"Software\WAPT", "TreeSize Free", "DisableContextMenuEntriesOnce")
